/*
 * font.c
 *
 *  a bitmapped font for use in the system
 *
 *  copied from the Turaco source code, December 1998
 *
 *  2000.01.02
 *  jsl@absynth.com
 *  Scott "Jerry" Lawrence
 */

/*
 * 4p - Pixel Pushing Paint Program
 * Copyright (C) 2000 Scott "Jerry" Lawrence
 *                    jsl.4p@absynth.com
 *
 *  This is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This software is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include "jsui.h"
#include <string.h>

// first... my internal font...
unsigned char __font_data[224][8] =
{
    { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },
    { 0x3c, 0x3c, 0x38, 0x38, 0x30, 0x00, 0x30, 0x00 },
    { 0x6c, 0x6c, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00 },
    { 0x6c, 0x6c, 0xfe, 0x6c, 0xfe, 0x6c, 0x6c, 0x00 },
    { 0x18, 0x7e, 0xc0, 0x7c, 0x06, 0xfc, 0x18, 0x00 },
    { 0x00, 0xc6, 0xcc, 0x18, 0x30, 0x66, 0xc6, 0x00 },
    { 0x38, 0x6c, 0x38, 0x76, 0xdc, 0xcc, 0x76, 0x00 },
    { 0x30, 0x30, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00 },
    { 0x0c, 0x18, 0x30, 0x30, 0x30, 0x18, 0x0c, 0x00 },
    { 0x30, 0x18, 0x0c, 0x0c, 0x0c, 0x18, 0x30, 0x00 },
    { 0x00, 0x66, 0x3c, 0xff, 0x3c, 0x66, 0x00, 0x00 },
    { 0x00, 0x18, 0x18, 0x7e, 0x18, 0x18, 0x00, 0x00 },
    { 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x30 },
    { 0x00, 0x00, 0x00, 0x7e, 0x00, 0x00, 0x00, 0x00 },
    { 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00 },
    { 0x06, 0x0c, 0x18, 0x30, 0x60, 0xc0, 0x80, 0x00 },
    { 0x7c, 0xc6, 0xce, 0xd6, 0xe6, 0xc6, 0x7c, 0x00 },
    { 0x18, 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00 },
    { 0x7c, 0xc6, 0x06, 0x7c, 0xc0, 0xc0, 0xfe, 0x00 },
    { 0xfc, 0x06, 0x06, 0x3c, 0x06, 0x06, 0xfc, 0x00 },
    { 0x0c, 0xcc, 0xcc, 0xcc, 0xfe, 0x0c, 0x0c, 0x00 },
    { 0xfe, 0xc0, 0xfc, 0x06, 0x06, 0xc6, 0x7c, 0x00 },
    { 0x7c, 0xc0, 0xc0, 0xfc, 0xc6, 0xc6, 0x7c, 0x00 },
    { 0xfe, 0x06, 0x06, 0x0c, 0x18, 0x30, 0x30, 0x00 },
    { 0x7c, 0xc6, 0xc6, 0x7c, 0xc6, 0xc6, 0x7c, 0x00 },
    { 0x7c, 0xc6, 0xc6, 0x7e, 0x06, 0x06, 0x7c, 0x00 },
    { 0x00, 0x18, 0x18, 0x00, 0x00, 0x18, 0x18, 0x00 },
    { 0x00, 0x18, 0x18, 0x00, 0x00, 0x18, 0x18, 0x30 },
    { 0x0c, 0x18, 0x30, 0x60, 0x30, 0x18, 0x0c, 0x00 },
    { 0x00, 0x00, 0x7e, 0x00, 0x7e, 0x00, 0x00, 0x00 },
    { 0x30, 0x18, 0x0c, 0x06, 0x0c, 0x18, 0x30, 0x00 },
    { 0x3c, 0x66, 0x0c, 0x18, 0x18, 0x00, 0x18, 0x00 },
    { 0x7c, 0xc6, 0xde, 0xde, 0xde, 0xc0, 0x7e, 0x00 },
    { 0x38, 0x6c, 0xc6, 0xc6, 0xfe, 0xc6, 0xc6, 0x00 },
    { 0xfc, 0xc6, 0xc6, 0xfc, 0xc6, 0xc6, 0xfc, 0x00 },
    { 0x7c, 0xc6, 0xc0, 0xc0, 0xc0, 0xc6, 0x7c, 0x00 },
    { 0xf8, 0xcc, 0xc6, 0xc6, 0xc6, 0xcc, 0xf8, 0x00 },
    { 0xfe, 0xc0, 0xc0, 0xf8, 0xc0, 0xc0, 0xfe, 0x00 },
    { 0xfe, 0xc0, 0xc0, 0xf8, 0xc0, 0xc0, 0xc0, 0x00 },
    { 0x7c, 0xc6, 0xc0, 0xc0, 0xce, 0xc6, 0x7c, 0x00 },
    { 0xc6, 0xc6, 0xc6, 0xfe, 0xc6, 0xc6, 0xc6, 0x00 },
    { 0x7e, 0x18, 0x18, 0x18, 0x18, 0x18, 0x7e, 0x00 },
    { 0x06, 0x06, 0x06, 0x06, 0x06, 0xc6, 0x7c, 0x00 },
    { 0xc6, 0xcc, 0xd8, 0xf0, 0xd8, 0xcc, 0xc6, 0x00 },
    { 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xfe, 0x00 },
    { 0xc6, 0xee, 0xfe, 0xfe, 0xd6, 0xc6, 0xc6, 0x00 },
    { 0xc6, 0xe6, 0xf6, 0xde, 0xce, 0xc6, 0xc6, 0x00 },
    { 0x7c, 0xc6, 0xc6, 0xc6, 0xc6, 0xc6, 0x7c, 0x00 },
    { 0xfc, 0xc6, 0xc6, 0xfc, 0xc0, 0xc0, 0xc0, 0x00 },
    { 0x7c, 0xc6, 0xc6, 0xc6, 0xd6, 0xde, 0x7c, 0x06 },
    { 0xfc, 0xc6, 0xc6, 0xfc, 0xd8, 0xcc, 0xc6, 0x00 },
    { 0x7c, 0xc6, 0xc0, 0x7c, 0x06, 0xc6, 0x7c, 0x00 },
    { 0xff, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00 },
    { 0xc6, 0xc6, 0xc6, 0xc6, 0xc6, 0xc6, 0xfe, 0x00 },
    { 0xc6, 0xc6, 0xc6, 0xc6, 0xc6, 0x7c, 0x38, 0x00 },
    { 0xc6, 0xc6, 0xc6, 0xc6, 0xd6, 0xfe, 0x6c, 0x00 },
    { 0xc6, 0xc6, 0x6c, 0x38, 0x6c, 0xc6, 0xc6, 0x00 },
    { 0xc6, 0xc6, 0xc6, 0x7c, 0x18, 0x30, 0xe0, 0x00 },
    { 0xfe, 0x06, 0x0c, 0x18, 0x30, 0x60, 0xfe, 0x00 },
    { 0x3c, 0x30, 0x30, 0x30, 0x30, 0x30, 0x3c, 0x00 },
    { 0xc0, 0x60, 0x30, 0x18, 0x0c, 0x06, 0x02, 0x00 },
    { 0x3c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x3c, 0x00 },
    { 0x10, 0x38, 0x6c, 0xc6, 0x00, 0x00, 0x00, 0x00 },
    { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff },
    { 0x18, 0x18, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00 },
    { 0x00, 0x00, 0x7c, 0x06, 0x7e, 0xc6, 0x7e, 0x00 },
    { 0xc0, 0xc0, 0xc0, 0xfc, 0xc6, 0xc6, 0xfc, 0x00 },
    { 0x00, 0x00, 0x7c, 0xc6, 0xc0, 0xc6, 0x7c, 0x00 },
    { 0x06, 0x06, 0x06, 0x7e, 0xc6, 0xc6, 0x7e, 0x00 },
    { 0x00, 0x00, 0x7c, 0xc6, 0xfe, 0xc0, 0x7c, 0x00 },
    { 0x1c, 0x36, 0x30, 0x78, 0x30, 0x30, 0x30, 0x00 },
    { 0x00, 0x00, 0x7e, 0xc6, 0xc6, 0x7e, 0x06, 0xfc },
    { 0xc0, 0xc0, 0xfc, 0xc6, 0xc6, 0xc6, 0xc6, 0x00 },
    { 0x18, 0x00, 0x38, 0x18, 0x18, 0x18, 0x18, 0x00 },
    { 0x06, 0x00, 0x06, 0x06, 0x06, 0x06, 0xc6, 0x7c },
    { 0xc0, 0xc0, 0xcc, 0xd8, 0xf8, 0xcc, 0xc6, 0x00 },
    { 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00 },
    { 0x00, 0x00, 0xcc, 0xfe, 0xfe, 0xd6, 0xd6, 0x00 },
    { 0x00, 0x00, 0xfc, 0xc6, 0xc6, 0xc6, 0xc6, 0x00 },
    { 0x00, 0x00, 0x7c, 0xc6, 0xc6, 0xc6, 0x7c, 0x00 },
    { 0x00, 0x00, 0xfc, 0xc6, 0xc6, 0xfc, 0xc0, 0xc0 },
    { 0x00, 0x00, 0x7e, 0xc6, 0xc6, 0x7e, 0x06, 0x06 },
    { 0x00, 0x00, 0xfc, 0xc6, 0xc0, 0xc0, 0xc0, 0x00 },
    { 0x00, 0x00, 0x7e, 0xc0, 0x7c, 0x06, 0xfc, 0x00 },
    { 0x18, 0x18, 0x7e, 0x18, 0x18, 0x18, 0x0e, 0x00 },
    { 0x00, 0x00, 0xc6, 0xc6, 0xc6, 0xc6, 0x7e, 0x00 },
    { 0x00, 0x00, 0xc6, 0xc6, 0xc6, 0x7c, 0x38, 0x00 },
    { 0x00, 0x00, 0xc6, 0xc6, 0xd6, 0xfe, 0x6c, 0x00 },
    { 0x00, 0x00, 0xc6, 0x6c, 0x38, 0x6c, 0xc6, 0x00 },
    { 0x00, 0x00, 0xc6, 0xc6, 0xc6, 0x7e, 0x06, 0xfc },
    { 0x00, 0x00, 0xfe, 0x0c, 0x38, 0x60, 0xfe, 0x00 },
    { 0x0e, 0x18, 0x18, 0x70, 0x18, 0x18, 0x0e, 0x00 },
    { 0x18, 0x18, 0x18, 0x00, 0x18, 0x18, 0x18, 0x00 },
    { 0x70, 0x18, 0x18, 0x0e, 0x18, 0x18, 0x70, 0x00 },
    { 0x76, 0xdc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },
    { 0x00, 0x10, 0x38, 0x6c, 0xc6, 0xc6, 0xfe, 0x00 },
    { 0x7c, 0xc6, 0xc0, 0xc0, 0xc0, 0xd6, 0x7c, 0x30 },
    { 0xc6, 0x00, 0xc6, 0xc6, 0xc6, 0xc6, 0x7e, 0x00 },
    { 0x0e, 0x00, 0x7c, 0xc6, 0xfe, 0xc0, 0x7c, 0x00 },
    { 0x7e, 0x81, 0x3c, 0x06, 0x7e, 0xc6, 0x7e, 0x00 },
    { 0x66, 0x00, 0x7c, 0x06, 0x7e, 0xc6, 0x7e, 0x00 },
    { 0xe0, 0x00, 0x7c, 0x06, 0x7e, 0xc6, 0x7e, 0x00 },
    { 0x18, 0x18, 0x7c, 0x06, 0x7e, 0xc6, 0x7e, 0x00 },
    { 0x00, 0x00, 0x7c, 0xc6, 0xc0, 0xd6, 0x7c, 0x30 },
    { 0x7e, 0x81, 0x7c, 0xc6, 0xfe, 0xc0, 0x7c, 0x00 },
    { 0x66, 0x00, 0x7c, 0xc6, 0xfe, 0xc0, 0x7c, 0x00 },
    { 0xe0, 0x00, 0x7c, 0xc6, 0xfe, 0xc0, 0x7c, 0x00 },
    { 0x66, 0x00, 0x38, 0x18, 0x18, 0x18, 0x3c, 0x00 },
    { 0x7c, 0x82, 0x38, 0x18, 0x18, 0x18, 0x3c, 0x00 },
    { 0x70, 0x00, 0x38, 0x18, 0x18, 0x18, 0x3c, 0x00 },
    { 0xc6, 0x10, 0x7c, 0xc6, 0xfe, 0xc6, 0xc6, 0x00 },
    { 0x38, 0x38, 0x00, 0x7c, 0xc6, 0xfe, 0xc6, 0x00 },
    { 0x0e, 0x00, 0xfe, 0xc0, 0xf8, 0xc0, 0xfe, 0x00 },
    { 0x00, 0x00, 0x7f, 0x0c, 0x7f, 0xcc, 0x7f, 0x00 },
    { 0x3f, 0x6c, 0xcc, 0xff, 0xcc, 0xcc, 0xcf, 0x00 },
    { 0x7c, 0x82, 0x7c, 0xc6, 0xc6, 0xc6, 0x7c, 0x00 },
    { 0x66, 0x00, 0x7c, 0xc6, 0xc6, 0xc6, 0x7c, 0x00 },
    { 0xe0, 0x00, 0x7c, 0xc6, 0xc6, 0xc6, 0x7c, 0x00 },
    { 0x7c, 0x82, 0x00, 0xc6, 0xc6, 0xc6, 0x7e, 0x00 },
    { 0xe0, 0x00, 0xc6, 0xc6, 0xc6, 0xc6, 0x7e, 0x00 },
    { 0x66, 0x00, 0x66, 0x66, 0x66, 0x3e, 0x06, 0x7c },
    { 0xc6, 0x7c, 0xc6, 0xc6, 0xc6, 0xc6, 0x7c, 0x00 },
    { 0xc6, 0x00, 0xc6, 0xc6, 0xc6, 0xc6, 0xfe, 0x00 },
    { 0x18, 0x18, 0x7e, 0xd8, 0xd8, 0xd8, 0x7e, 0x18 },
    { 0x38, 0x6c, 0x60, 0xf0, 0x60, 0x66, 0xfc, 0x00 },
    { 0x66, 0x66, 0x3c, 0x18, 0x7e, 0x18, 0x7e, 0x18 },
    { 0xf8, 0xcc, 0xcc, 0xfa, 0xc6, 0xcf, 0xc6, 0xc3 },
    { 0x0e, 0x1b, 0x18, 0x3c, 0x18, 0x18, 0xd8, 0x70 },
    { 0x0e, 0x00, 0x7c, 0x06, 0x7e, 0xc6, 0x7e, 0x00 },
    { 0x1c, 0x00, 0x38, 0x18, 0x18, 0x18, 0x3c, 0x00 },
    { 0x0e, 0x00, 0x7c, 0xc6, 0xc6, 0xc6, 0x7c, 0x00 },
    { 0x0e, 0x00, 0xc6, 0xc6, 0xc6, 0xc6, 0x7e, 0x00 },
    { 0x00, 0xfe, 0x00, 0xfc, 0xc6, 0xc6, 0xc6, 0x00 },
    { 0xfe, 0x00, 0xc6, 0xe6, 0xf6, 0xde, 0xce, 0x00 },
    { 0x3c, 0x6c, 0x6c, 0x3e, 0x00, 0x7e, 0x00, 0x00 },
    { 0x3c, 0x66, 0x66, 0x3c, 0x00, 0x7e, 0x00, 0x00 },
    { 0x18, 0x00, 0x18, 0x18, 0x30, 0x66, 0x3c, 0x00 },
    { 0x00, 0x00, 0x00, 0xfc, 0xc0, 0xc0, 0x00, 0x00 },
    { 0x00, 0x00, 0x00, 0xfc, 0x0c, 0x0c, 0x00, 0x00 },
    { 0xc6, 0xcc, 0xd8, 0x3f, 0x63, 0xcf, 0x8c, 0x0f },
    { 0xc3, 0xc6, 0xcc, 0xdb, 0x37, 0x6d, 0xcf, 0x03 },
    { 0x18, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00 },
    { 0x00, 0x33, 0x66, 0xcc, 0x66, 0x33, 0x00, 0x00 },
    { 0x00, 0xcc, 0x66, 0x33, 0x66, 0xcc, 0x00, 0x00 },
    { 0x22, 0x88, 0x22, 0x88, 0x22, 0x88, 0x22, 0x88 },
    { 0x55, 0xaa, 0x55, 0xaa, 0x55, 0xaa, 0x55, 0xaa },
    { 0xdd, 0x77, 0xdd, 0x77, 0xdd, 0x77, 0xdd, 0x77 },
    { 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18 },
    { 0x18, 0x18, 0x18, 0x18, 0xf8, 0x18, 0x18, 0x18 },
    { 0x18, 0x18, 0xf8, 0x18, 0xf8, 0x18, 0x18, 0x18 },
    { 0x36, 0x36, 0x36, 0x36, 0xf6, 0x36, 0x36, 0x36 },
    { 0x00, 0x00, 0x00, 0x00, 0xfe, 0x36, 0x36, 0x36 },
    { 0x00, 0x00, 0xf8, 0x18, 0xf8, 0x18, 0x18, 0x18 },
    { 0x36, 0x36, 0xf6, 0x06, 0xf6, 0x36, 0x36, 0x36 },
    { 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36 },
    { 0x00, 0x00, 0xfe, 0x06, 0xf6, 0x36, 0x36, 0x36 },
    { 0x36, 0x36, 0xf6, 0x06, 0xfe, 0x00, 0x00, 0x00 },
    { 0x36, 0x36, 0x36, 0x36, 0xfe, 0x00, 0x00, 0x00 },
    { 0x18, 0x18, 0xf8, 0x18, 0xf8, 0x00, 0x00, 0x00 },
    { 0x00, 0x00, 0x00, 0x00, 0xf8, 0x18, 0x18, 0x18 },
    { 0x18, 0x18, 0x18, 0x18, 0x1f, 0x00, 0x00, 0x00 },
    { 0x18, 0x18, 0x18, 0x18, 0xff, 0x00, 0x00, 0x00 },
    { 0x00, 0x00, 0x00, 0x00, 0xff, 0x18, 0x18, 0x18 },
    { 0x18, 0x18, 0x18, 0x18, 0x1f, 0x18, 0x18, 0x18 },
    { 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00, 0x00 },
    { 0x18, 0x18, 0x18, 0x18, 0xff, 0x18, 0x18, 0x18 },
    { 0x18, 0x18, 0x1f, 0x18, 0x1f, 0x18, 0x18, 0x18 },
    { 0x36, 0x36, 0x36, 0x36, 0x37, 0x36, 0x36, 0x36 },
    { 0x36, 0x36, 0x37, 0x30, 0x3f, 0x00, 0x00, 0x00 },
    { 0x00, 0x00, 0x3f, 0x30, 0x37, 0x36, 0x36, 0x36 },
    { 0x36, 0x36, 0xf7, 0x00, 0xff, 0x00, 0x00, 0x00 },
    { 0x00, 0x00, 0xff, 0x00, 0xf7, 0x36, 0x36, 0x36 },
    { 0x36, 0x36, 0x37, 0x30, 0x37, 0x36, 0x36, 0x36 },
    { 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0x00, 0x00 },
    { 0x36, 0x36, 0xf7, 0x00, 0xf7, 0x36, 0x36, 0x36 },
    { 0x18, 0x18, 0xff, 0x00, 0xff, 0x00, 0x00, 0x00 },
    { 0x36, 0x36, 0x36, 0x36, 0xff, 0x00, 0x00, 0x00 },
    { 0x00, 0x00, 0xff, 0x00, 0xff, 0x18, 0x18, 0x18 },
    { 0x00, 0x00, 0x00, 0x00, 0xff, 0x36, 0x36, 0x36 },
    { 0x36, 0x36, 0x36, 0x36, 0x3f, 0x00, 0x00, 0x00 },
    { 0x18, 0x18, 0x1f, 0x18, 0x1f, 0x00, 0x00, 0x00 },
    { 0x00, 0x00, 0x1f, 0x18, 0x1f, 0x18, 0x18, 0x18 },
    { 0x00, 0x00, 0x00, 0x00, 0x3f, 0x36, 0x36, 0x36 },
    { 0x36, 0x36, 0x36, 0x36, 0xff, 0x36, 0x36, 0x36 },
    { 0x18, 0x18, 0xff, 0x18, 0xff, 0x18, 0x18, 0x18 },
    { 0x18, 0x18, 0x18, 0x18, 0xf8, 0x00, 0x00, 0x00 },
    { 0x00, 0x00, 0x00, 0x00, 0x1f, 0x18, 0x18, 0x18 },
    { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff },
    { 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff },
    { 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0, 0xf0 },
    { 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f },
    { 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00 },
    { 0x00, 0x00, 0x76, 0xdc, 0xc8, 0xdc, 0x76, 0x00 },
    { 0x38, 0x6c, 0x6c, 0x78, 0x6c, 0x66, 0x6c, 0x60 },
    { 0x00, 0xfe, 0xc6, 0xc0, 0xc0, 0xc0, 0xc0, 0x00 },
    { 0x00, 0x00, 0xfe, 0x6c, 0x6c, 0x6c, 0x6c, 0x00 },
    { 0xfe, 0x60, 0x30, 0x18, 0x30, 0x60, 0xfe, 0x00 },
    { 0x00, 0x00, 0x7e, 0xd8, 0xd8, 0xd8, 0x70, 0x00 },
    { 0x00, 0x66, 0x66, 0x66, 0x66, 0x7c, 0x60, 0xc0 },
    { 0x00, 0x76, 0xdc, 0x18, 0x18, 0x18, 0x18, 0x00 },
    { 0x7e, 0x18, 0x3c, 0x66, 0x66, 0x3c, 0x18, 0x7e },
    { 0x3c, 0x66, 0xc3, 0xff, 0xc3, 0x66, 0x3c, 0x00 },
    { 0x3c, 0x66, 0xc3, 0xc3, 0x66, 0x66, 0xe7, 0x00 },
    { 0x0e, 0x18, 0x0c, 0x7e, 0xc6, 0xc6, 0x7c, 0x00 },
    { 0x00, 0x00, 0x7e, 0xdb, 0xdb, 0x7e, 0x00, 0x00 },
    { 0x06, 0x0c, 0x7e, 0xdb, 0xdb, 0x7e, 0x60, 0xc0 },
    { 0x38, 0x60, 0xc0, 0xf8, 0xc0, 0x60, 0x38, 0x00 },
    { 0x78, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0x00 },
    { 0x00, 0x7e, 0x00, 0x7e, 0x00, 0x7e, 0x00, 0x00 },
    { 0x18, 0x18, 0x7e, 0x18, 0x18, 0x00, 0x7e, 0x00 },
    { 0x60, 0x30, 0x18, 0x30, 0x60, 0x00, 0xfc, 0x00 },
    { 0x18, 0x30, 0x60, 0x30, 0x18, 0x00, 0xfc, 0x00 },
    { 0x0e, 0x1b, 0x1b, 0x18, 0x18, 0x18, 0x18, 0x18 },
    { 0x18, 0x18, 0x18, 0x18, 0x18, 0xd8, 0xd8, 0x70 },
    { 0x18, 0x18, 0x00, 0x7e, 0x00, 0x18, 0x18, 0x00 },
    { 0x00, 0x76, 0xdc, 0x00, 0x76, 0xdc, 0x00, 0x00 },
    { 0x38, 0x6c, 0x6c, 0x38, 0x00, 0x00, 0x00, 0x00 },
    { 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00 },
    { 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00 },
    { 0x0f, 0x0c, 0x0c, 0x0c, 0xec, 0x6c, 0x3c, 0x1c },
    { 0x78, 0x6c, 0x6c, 0x6c, 0x6c, 0x00, 0x00, 0x00 },
    { 0x7c, 0x0c, 0x7c, 0x60, 0x7c, 0x00, 0x00, 0x00 },
    { 0x00, 0x00, 0x3c, 0x3c, 0x3c, 0x3c, 0x00, 0x00 },
    { 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }
};

// for the intnernal font (Zarnox)
FONT_DEFINITION jsui_standard_font = 
{
    8, 8, 
    ' ', ' '+224, 
    (unsigned char *) __font_data
};

FONT_DEFINITION * jsui_current_font = &jsui_standard_font;

// for our referencing, we'll need this...
unsigned char __fontbits[8] = { 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};


void
font_render_char(
	IPAGE * dest,
	PEN * fgpen,
	PEN * bgpen,
	FONT_DEFINITION * font,
	int x,
	int y,
	int c
)
{
    int row, pix;
    int offset, foffset;

    row = 0;
    offset = (dest->w * y) + x;

    if (dest->ncolors <= 0)
    {
	for (row = 0 ; row < font->h ; row ++)
	{
	    foffset = (c * font->w) + row;
	    for (pix = 0 ; pix < font->w && pix < 8 ; pix++) 
	    {
		if (font->data[foffset] & __fontbits[pix])
		{
		    dest->timage[offset+pix].r = fgpen->RGBcolor.r;
		    dest->timage[offset+pix].g = fgpen->RGBcolor.g;
		    dest->timage[offset+pix].b = fgpen->RGBcolor.b;
		}
	    }
	    offset += dest->w;
	}
    } else {
	for (row = 0 ; row < font->h ; row ++)
	{
	    foffset = (c * font->w) + row;
	    for (pix = 0 ; pix < font->w && pix < 8 ; pix++) 
	    {
		if (font->data[foffset] & __fontbits[pix])
		{
		    dest->pimage[offset+pix] = fgpen->Icolor;
		}
	    }
	    offset += dest->w;
	}
    }
}


void
font_render_char_BG(
	IPAGE * dest,
	PEN * fgpen, 
	PEN * bgpen, 
	FONT_DEFINITION * font,
	int x,
	int y,
	int c
)
{
    int row, pix;
    int offset, foffset;

    row = 0;
    offset = (dest->w * y) + x;

    if (dest->ncolors <= 0)
    {
	for (row = 0 ; row < font->h ; row ++)
	{
	    foffset = (c * font->w) + row;
	    for (pix = 0 ; pix < font->w && pix < 8 ; pix++) 
	    {
		if (font->data[foffset] & __fontbits[pix])
		{
		    dest->timage[offset+pix].r = fgpen->RGBcolor.r;
		    dest->timage[offset+pix].g = fgpen->RGBcolor.g;
		    dest->timage[offset+pix].b = fgpen->RGBcolor.b;
		}
		else
		{
		    dest->timage[offset+pix].r = bgpen->RGBcolor.r;
		    dest->timage[offset+pix].g = bgpen->RGBcolor.g;
		    dest->timage[offset+pix].b = bgpen->RGBcolor.b;
		}
	    }
	    offset += dest->w;
	}
    } else {
	for (row = 0 ; row < font->h ; row ++)
	{
	    foffset = (c * font->w) + row;
	    for (pix = 0 ; pix < font->w && pix < 8 ; pix++) 
	    {
		if (font->data[foffset] & __fontbits[pix])
		{
		    dest->pimage[offset+pix] = fgpen->Icolor;
		}
		else
		    dest->pimage[offset+pix] = bgpen->Icolor;
	    }
	    offset += dest->w;
	}
    }
}


void 
font_render_text(
	IPAGE * dest, 
	PEN * fgpen, 
	PEN * bgpen, 
	FONT_DEFINITION * font,
	int x, 
	int y, 
	char * text
)
{
    int c;
    int maxchar = 0;
    if (!dest || !fgpen || !bgpen || !font || !text)  return;
    if (!font->data) return;

    maxchar = ((dest->w - x -1) / font->w); // for simple clipping

    if (fgpen->text_type == TEXT_TYPE_JAM1)
    {
	for (c=0 ; text[c] != '\0' && c < maxchar; c++)
	{
	    font_render_char(dest, fgpen, bgpen, font, 
				    x+(c*font->w), y, 
				    text[c]-font->min_ascii);
	}
    } else { /* assume it's JAM2 for now */
	for (c=0 ; text[c] != '\0' && c < maxchar; c++)
	{
	    font_render_char_BG(dest, fgpen, bgpen, font, 
				    x+(c*font->w), y, 
				    text[c]-font->min_ascii);
	}
    }
    
    Page_DR_Dirtify(dest, x,y, x+(font->w*c), y+font->h);
}


void
font_render_text_center(
	IPAGE * dest, 
	PEN * fgpen, 
	PEN * bgpen, 
	FONT_DEFINITION * font,
	int x, 
	int y, 
	char * text
)
{
    if (!font || !text) return;

    font_render_text(dest, fgpen, bgpen, font, 
		x - (font->w * strlen(text))/2,
		y,text);
}


void
font_render_text_right(
	IPAGE * dest, 
	PEN * fgpen, 
	PEN * bgpen, 
	FONT_DEFINITION * font,
	int x, 
	int y, 
	char * text
)
{
    if (!font || !text) return;

    font_render_text(dest, fgpen, bgpen, font, 
		x - (font->w * strlen(text)),
		y,text);
}
